/* --------------------------------------------------------------------------------------------------- 
 * BuildTool - Custom / Extra Javascript
 * 
 * @author	AppResponsive <http://buildtool.com/>
 * @version	2.1
 *
 * Copyright (C) 2013 - 2015 AppResponsive. All rights reserved.
 * 
 * This is the code that will be loaded after the app has been initialized. It will:
 *
 * - Set Push Notifications
 * - Set Stats
 * - Set Ads
 * - Set Testing
 * - Set iOS specific options
 * - Set Android specific options
 *
 * -------------------------------------------------------------------------------------------------- */

/*
 * BuildTool Settings
 */
var config = "bt_config.xml";

/*
 * BuildTool Extra Settings
 */
var bt_location;
var bt_app_id;
var bt_app_name;
var bt_app_identifier;

var push_custom_enable;
var push_pushwoosh_enable;
var push_pushapps_enable;
var push_gamethrive_enable;
var push_android_enable;
var push_android_senderid;
var push_ios_enable;
var push_pushwoosh_senderid;
var push_pushwoosh_appid;
var push_pushapps_senderid;
var push_pushapps_token;
var push_gamethrive_senderid;
var push_gamethrive_token;
var push_urbanairship_enable;
var push_infobip_enable;
var push_infobip_senderid;
var push_infobip_id;
var push_infobip_secret;
var push_ibm_enable;
var push_ibm_route;
var push_ibm_id;
var push_ibm_secret;

var stats_bt_enable;
var stats_ga_enable;
var stats_ga_accountid;
var stats_distimo_enable;
var stats_distimo_sdkkey;
var stats_tapstream_enable;
var stats_tapstream_accountname;
var stats_tapstream_sdksecret;
var stats_tapstream_idfa;
var stats_zendrive_enable;
var stats_zendrive_key;
var stats_telerik_enable;
var stats_telerik_key;
var stats_appsee_enable;
var stats_appsee_key;

var ads_iads_enable;
var ads_iads_position;
var ads_iads_overlap;
var ads_iads_type;
var ads_admob_enable;
var ads_admob_ioskey;
var ads_admob_androidkey;
var ads_admob_winphonekey;
var ads_admob_type;
var ads_admob_position;
var ads_admob_overlap;
var ads_inmobi_enable;
var ads_inmobi_siteid;
var ads_inmobi_type;
var ads_inmobi_position;
var ads_facebook_enable;
var ads_facebook_ios_id;
var ads_facebook_android_id;
var ads_facebook_type;
var ads_facebook_position;
var ads_facebook_overlap;
var ads_flurry_enable;
var ads_flurry_ios_id;
var ads_flurry_android_id;
var ads_flurry_type;
var ads_flurry_position;
var ads_flurry_overlap;
var ads_mmedia_enable;
var ads_mmedia_ios_id;
var ads_mmedia_android_id;
var ads_mmedia_type;
var ads_mmedia_position;
var ads_mmedia_overlap;
var ads_mobfox_enable;
var ads_mobfox_ios_id;
var ads_mobfox_android_id;
var ads_mobfox_type;
var ads_mobfox_position;
var ads_mobfox_overlap;
var ads_mopub_enable;
var ads_mopub_ios_id;
var ads_mopub_android_id;
var ads_mopub_type;
var ads_mopub_position;
var ads_mopub_overlap;

var specific_ios_showstatusbar;
var specific_ios_overlaystatusbar;
var specific_ios_statusbarstyle;

var rate_ios_enable;
var rate_android_enable;
var rate_winphone_enable;
var rate_ios_appid;
var rate_ios_language;
var rate_android_language;
var rate_winphone_language;

var testing_testflight_enable;
var testing_testflight_token;
var testing_lookback_enable;
var testing_lookback_token;
var testing_repro_enable;
var testing_repro_token;

/* --------------------------------------------------------------------------------------------------- */

/*
 * When Device Ready
 */
 
document.addEventListener("deviceReady", function()
{
	// Get all the extra options from the config.
	$.get(config, function(data)
	{
		// Get data
		if(data)
		{		
			bt_location						= $(data).find('bt_extra[setting=bt_location]').attr('value');
			bt_app_id						= $(data).find('bt_extra[setting=bt_app_id]').attr('value');
			bt_app_name						= $(data).find('bt_extra[setting=bt_app_name]').attr('value');
			bt_app_identifier				= $(data).find('bt_extra[setting=bt_app_identifier]').attr('value');
			
			push_custom_enable				= $(data).find('bt_extra[setting=push_custom_enable]').attr('value');
			push_pushwoosh_enable			= $(data).find('bt_extra[setting=push_pushwoosh_enable]').attr('value');
			push_pushapps_enable			= $(data).find('bt_extra[setting=push_pushapps_enable]').attr('value');
			push_gamethrive_enable			= $(data).find('bt_extra[setting=push_gamethrive_enable]').attr('value');
			push_android_enable				= $(data).find('bt_extra[setting=push_android_enable]').attr('value');
			push_android_senderid			= $(data).find('bt_extra[setting=push_android_senderid]').attr('value');
			push_ios_enable					= $(data).find('bt_extra[setting=push_ios_enable]').attr('value');
			push_pushwoosh_senderid			= $(data).find('bt_extra[setting=push_pushwoosh_senderid]').attr('value');
			push_pushwoosh_appid			= $(data).find('bt_extra[setting=push_pushwoosh_appid]').attr('value');
			push_pushapps_senderid			= $(data).find('bt_extra[setting=push_pushapps_senderid]').attr('value');
			push_pushapps_token				= $(data).find('bt_extra[setting=push_pushapps_token]').attr('value');
			push_gamethrive_senderid		= $(data).find('bt_extra[setting=push_gamethrive_senderid]').attr('value');
			push_gamethrive_token			= $(data).find('bt_extra[setting=push_gamethrive_token]').attr('value');
			push_urbanairship_enable		= $(data).find('bt_extra[setting=push_urbanairship_enable]').attr('value');
			push_infobip_enable				= $(data).find('bt_extra[setting=push_infobip_enable]').attr('value');
			push_infobip_senderid			= $(data).find('bt_extra[setting=push_infobip_senderid]').attr('value');
			push_infobip_id					= $(data).find('bt_extra[setting=push_infobip_id]').attr('value');
			push_infobip_secret				= $(data).find('bt_extra[setting=push_infobip_secret]').attr('value');
			push_ibm_enable					= $(data).find('bt_extra[setting=push_ibm_enable]').attr('value');
			push_ibm_route					= $(data).find('bt_extra[setting=push_ibm_route]').attr('value');
			push_ibm_id						= $(data).find('bt_extra[setting=push_ibm_id]').attr('value');
			push_ibm_secret					= $(data).find('bt_extra[setting=push_ibm_secret]').attr('value');
			
			stats_bt_enable					= $(data).find('bt_extra[setting=stats_bt_enable]').attr('value');
			stats_ga_enable					= $(data).find('bt_extra[setting=stats_ga_enable]').attr('value');
			stats_ga_accountid				= $(data).find('bt_extra[setting=stats_ga_accountid]').attr('value');
			stats_distimo_enable			= $(data).find('bt_extra[setting=stats_distimo_enable]').attr('value');
			stats_distimo_accountid			= $(data).find('bt_extra[setting=stats_distimo_sdkkey]').attr('value');
			stats_tapstream_enable			= $(data).find('bt_extra[setting=stats_tapstream_enable]').attr('value');
			stats_tapstream_accountname		= $(data).find('bt_extra[setting=stats_tapstream_accountname]').attr('value');
			stats_tapstream_sdksecret		= $(data).find('bt_extra[setting=stats_tapstream_sdksecret]').attr('value');
			stats_tapstream_idfa			= $(data).find('bt_extra[setting=stats_tapstream_idfa]').attr('value');
			stats_zendrive_enable			= $(data).find('bt_extra[setting=stats_zendrive_enable]').attr('value');
			stats_zendrive_key				= $(data).find('bt_extra[setting=stats_zendrive_key]').attr('value');
			stats_telerik_enable			= $(data).find('bt_extra[setting=stats_telerik_enable]').attr('value');
			stats_telerik_key				= $(data).find('bt_extra[setting=stats_telerik_key]').attr('value');
			stats_appsee_enable				= $(data).find('bt_extra[setting=stats_appsee_enable]').attr('value');
			stats_appsee_key				= $(data).find('bt_extra[setting=stats_appsee_key]').attr('value');
			
			ads_iads_enable					= $(data).find('bt_extra[setting=ads_iads_enable]').attr('value');
			ads_iads_position				= $(data).find('bt_extra[setting=ads_iads_position]').attr('value');
			ads_iads_overlap				= $(data).find('bt_extra[setting=ads_iads_overlap]').attr('value');
			ads_iads_type					= $(data).find('bt_extra[setting=ads_iads_type]').attr('value');
			ads_admob_enable				= $(data).find('bt_extra[setting=ads_admob_enable]').attr('value');
			ads_admob_ioskey				= $(data).find('bt_extra[setting=ads_admob_ioskey]').attr('value');
			ads_admob_androidkey			= $(data).find('bt_extra[setting=ads_admob_androidkey]').attr('value');
			ads_admob_winphonekey			= $(data).find('bt_extra[setting=ads_admob_winphonekey]').attr('value');
			ads_admob_type					= $(data).find('bt_extra[setting=ads_admob_type]').attr('value');
			ads_admob_position				= $(data).find('bt_extra[setting=ads_admob_position]').attr('value');
			ads_admob_overlap				= $(data).find('bt_extra[setting=ads_admob_overlap]').attr('value');
			ads_inmobi_enable				= $(data).find('bt_extra[setting=ads_inmobi_enable]').attr('value');
			ads_inmobi_siteid				= $(data).find('bt_extra[setting=ads_inmobi_siteid]').attr('value');
			ads_inmobi_type					= $(data).find('bt_extra[setting=ads_inmobi_type]').attr('value');
			ads_inmobi_position				= $(data).find('bt_extra[setting=ads_inmobi_position]').attr('value');
			ads_facebook_enable				= $(data).find('bt_extra[setting=ads_facebook_enable]').attr('value');
			ads_facebook_ios_id				= $(data).find('bt_extra[setting=ads_facebook_ios_id]').attr('value');
			ads_facebook_android_id			= $(data).find('bt_extra[setting=ads_facebook_android_id]').attr('value');
			ads_facebook_type				= $(data).find('bt_extra[setting=ads_facebook_type]').attr('value');
			ads_facebook_position			= $(data).find('bt_extra[setting=ads_facebook_position]').attr('value');
			ads_facebook_overlap			= $(data).find('bt_extra[setting=ads_facebook_overlap]').attr('value');
			ads_flurry_enable				= $(data).find('bt_extra[setting=ads_flurry_enable]').attr('value');
			ads_flurry_ios_id				= $(data).find('bt_extra[setting=ads_flurry_ios_id]').attr('value');
			ads_flurry_android_id			= $(data).find('bt_extra[setting=ads_flurry_android_id]').attr('value');
			ads_flurry_type					= $(data).find('bt_extra[setting=ads_flurry_type]').attr('value');
			ads_flurry_position				= $(data).find('bt_extra[setting=ads_flurry_position]').attr('value');
			ads_flurry_overlap				= $(data).find('bt_extra[setting=ads_flurry_overlap]').attr('value');
			ads_mmedia_enable				= $(data).find('bt_extra[setting=ads_mmedia_enable]').attr('value');
			ads_mmedia_ios_id				= $(data).find('bt_extra[setting=ads_mmedia_ios_id]').attr('value');
			ads_mmedia_android_id			= $(data).find('bt_extra[setting=ads_mmedia_android_id]').attr('value');
			ads_mmedia_type					= $(data).find('bt_extra[setting=ads_mmedia_type]').attr('value');
			ads_mmedia_position				= $(data).find('bt_extra[setting=ads_mmedia_position]').attr('value');
			ads_mmedia_overlap				= $(data).find('bt_extra[setting=ads_mmedia_overlap]').attr('value');
			ads_mobfox_enable				= $(data).find('bt_extra[setting=ads_mobfox_enable]').attr('value');
			ads_mobfox_ios_id				= $(data).find('bt_extra[setting=ads_mobfox_ios_id]').attr('value');
			ads_mobfox_android_id			= $(data).find('bt_extra[setting=ads_mobfox_android_id]').attr('value');
			ads_mobfox_type					= $(data).find('bt_extra[setting=ads_mobfox_type]').attr('value');
			ads_mobfox_position				= $(data).find('bt_extra[setting=ads_mobfox_position]').attr('value');
			ads_mobfox_overlap				= $(data).find('bt_extra[setting=ads_mobfox_overlap]').attr('value');
			ads_mopub_enable				= $(data).find('bt_extra[setting=ads_mopub_enable]').attr('value');
			ads_mopub_ios_id				= $(data).find('bt_extra[setting=ads_mopub_ios_id]').attr('value');
			ads_mopub_android_id			= $(data).find('bt_extra[setting=ads_mopub_android_id]').attr('value');
			ads_mopub_type					= $(data).find('bt_extra[setting=ads_mopub_type]').attr('value');
			ads_mopub_position				= $(data).find('bt_extra[setting=ads_mopub_position]').attr('value');
			ads_mopub_overlap				= $(data).find('bt_extra[setting=ads_mopub_overlap]').attr('value');
			
			specific_ios_showstatusbar 		= $(data).find('bt_extra[setting=specific_ios_showstatusbar]').attr('value');
			specific_ios_overlaystatusbar 	= $(data).find('bt_extra[setting=specific_ios_overlaystatusbar]').attr('value');
			specific_ios_statusbarstyle 	= $(data).find('bt_extra[setting=specific_ios_statusbarstyle]').attr('value');
			
			rate_ios_enable 				= $(data).find('bt_extra[setting=rate_ios_enable]').attr('value');
			rate_android_enable				= $(data).find('bt_extra[setting=rate_android_enable]').attr('value');
			rate_winphone_enable			= $(data).find('bt_extra[setting=rate_winphone_enable]').attr('value');
			rate_ios_appid					= $(data).find('bt_extra[setting=rate_ios_appid]').attr('value');
			rate_ios_language				= $(data).find('bt_extra[setting=rate_ios_language]').attr('value');
			rate_android_language			= $(data).find('bt_extra[setting=rate_android_language]').attr('value');
			rate_winphone_language			= $(data).find('bt_extra[setting=rate_winphone_language]').attr('value');
			
			testing_testflight_enable		= $(data).find('bt_extra[setting=testing_testflight_enable]').attr('value');
			testing_testflight_token		= $(data).find('bt_extra[setting=testing_testflight_token]').attr('value');
			testing_lookback_enable			= $(data).find('bt_extra[setting=testing_lookback_enable]').attr('value');
			testing_lookback_token			= $(data).find('bt_extra[setting=testing_lookback_token]').attr('value');
			testing_repro_enable			= $(data).find('bt_extra[setting=testing_repro_enable]').attr('value');
			testing_repro_token				= $(data).find('bt_extra[setting=testing_repro_token]').attr('value');
			
			// Setup
			bt_setup();
		}
	});
}, false);

/* --------------------------------------------------------------------------------------------------- */

/*
 * Setup
 */
 
function bt_setup()
{
	// Enable BuildTool Push
	if(push_custom_enable == "1")
	{
		bt_setup_push_buildtool();
	}
	
	// Enable PushWoosh Push
	if(push_pushwoosh_enable == "1")
	{
		bt_setup_push_pushwoosh();
	}

	// Enable PushApps Push
	if(push_pushapps_enable == "1")
	{
		bt_setup_push_pushapps();
	}
	
	// Enable GameThrive Push
	if(push_gamethrive_enable == "1")
	{
		bt_setup_push_gamethrive();
	}
	
	// Enable Urban Airship Push
	if(push_urbanairship_enable == "1")
	{
		bt_setup_push_urbanairship();
	}
	
	// Enable Infobip Push
	if(push_infobip_enable == "1")
	{
		bt_setup_push_infobip();
	}
	
	// Enable IBM Push
	if(push_ibm_enable == "1")
	{
		bt_setup_push_ibm();
	}
	
	// Setup BuildTool Analytics
	if(stats_bt_enable == "1")
	{
		bt_setup_stats_bt();
	}
	
	// Setup Google Analytics
	if(stats_ga_enable == "1")
	{
		bt_setup_stats_ga();
	}
	
	// Setup Distimo
	if(stats_distimo_enable == "1")
	{
		bt_setup_stats_distimo();
	}
	
	// Setup Tapstream
	if(stats_tapstream_enable == "1")
	{
		bt_setup_stats_tapstream();
	}
	
	// Setup Zendrive
	if(stats_zendrive_enable == "1")
	{
		bt_setup_stats_zendrive();
	}
	
	// Setup Telerik
	if(stats_telerik_enable == "1")
	{
		bt_setup_stats_telerik();
	}
	
	// Setup Appsee
	if(stats_appsee_enable == "1")
	{
		bt_setup_stats_appsee();
	}
	
	// Setup iAd Ads
	if(ads_iads_enable == "1")
	{
		bt_setup_ads_iad();
	}
	
	// Setup Admob Ads
	if(ads_admob_enable == "1")
	{
		bt_setup_ads_admob();
	}
	
	// Setup Inmobi Ads
	if(ads_inmobi_enable == "1")
	{
		bt_setup_ads_inmobi();
	}
	
	// Setup Facebook Ads
	if(ads_facebook_enable == "1")
	{
		bt_setup_ads_facebook();
	}
	
	// Setup Flurry Ads
	if(ads_flurry_enable == "1")
	{
		bt_setup_ads_flurry();
	}
	
	// Setup Millenial Media Ads
	if(ads_mmedia_enable == "1")
	{
		bt_setup_ads_mmedia();
	}
	
	// Setup MobFox Ads
	if(ads_mobfox_enable == "1")
	{
		bt_setup_ads_mobfox();
	}
	
	// Setup MoPub Ads
	if(ads_mopub_enable == "1")
	{
		bt_setup_ads_mopub();
	}
	
	// Hide Statusbar on iOS7
	if(specific_ios_showstatusbar != "1")
	{
		bt_setup_ios_hidestatusbar();
	}
	else
	{
		// Overlay Statusbar on iOS7
		if(specific_ios_overlaystatusbar == "1")
		{
			bt_setup_ios_overlaystatusbar();
		}
	}
	
	// Enable App Rating
	if(rate_ios_enable == "1" || rate_android_enable == "1" || rate_winphone_enable == "1")
	{
		bt_setup_rate();
	}
	
	// Enable Testflight
	if(testing_testflight_enable == "1")
	{
		bt_setup_testflight();
	}
	
	// Enable Lookback
	if(testing_lookback_enable == "1")
	{
		bt_setup_lookback();
	}
	
	// Enable Lookback
	if(testing_repro_enable == "1")
	{
		bt_setup_repro();
	}
}

/* --------------------------------------------------------------------------------------------------- */

/*
 * Setup Push Notifications with BuildTool
 */
function bt_setup_push_buildtool()
{
	if(typeof window.plugins.pushNotification !== 'undefined')
	{
		if (device.platform == 'android' || device.platform == 'Android' || device.platform == "amazon-fireos" )
		{
			// Setup Android Push Notifications
			if(push_android_enable == "1")
			{
				try 
				{ 
					window.plugins.pushNotification.register(
						successHandler,
						errorHandler,
						{
							"senderID": push_android_senderid,
							"ecb": "onNotificationGCM"
						}
					);
				}
				catch(err) 
				{
					//console.log(err.message);
				} 
			}
		}
		else if (device.platform == 'ios' || device.platform == 'iOS')
		{
			// Setup iOS Push Notifications
			if(push_ios_enable == "1")
			{
				try
				{ 
					window.plugins.pushNotification.register(
						tokenHandler,
						errorHandler,
						{
							"badge":"true",
							"sound":"true",
							"alert":"true",
							"ecb":"onNotificationAPN"
						}
					);
				}
				catch(err) 
				{
					//console.log(err.message);
				} 
			}
		}
	}
}

/*
 * Setup Push Notifications with GameThrive
 */
function bt_setup_push_gamethrive()
{
	if(typeof GameThrive !== 'undefined')
	{
		if(device.platform == 'android' || device.platform == 'Android')
		{
			try
			{
				// Setup Android Push Notifications
				window.plugins.GameThrive.register(
					successHandler,
					errorHandler,
					{
						"senderID": push_gamethrive_senderid,
						"ecb": "onNotificationGCMGameThrive"
					}
				);
			}
			catch(err) 
			{
				//console.log(err.message);
			} 
		}
		else if (device.platform == 'ios' || device.platform == 'iOS')
		{
			try
			{ 
				window.plugins.GameThrive.register(
					tokenHandlerGameThrive,
					errorHandler,
					{
					  "badge":"true",
					  "sound":"true",
					  "alert":"true",
					  "ecb":"onNotificationAPNGameThrive"
					}
				);
			}
			catch(err) 
			{
				//console.log(err.message);
			} 
		}
	}
}
	
/*
 * Setup Push Notifications with PushWoosh
 */
function bt_setup_push_pushwoosh()
{
	if(typeof window.plugins.pushNotification !== 'undefined')
	{
		if (device.platform == 'android' || device.platform == 'Android')
		{
			// Handle notifications
			document.addEventListener('push-notification', function(event)
			{
				var message = event.notification.title;
	
				if(message && message.length > 0 && message != "null")
				{
					var header = "Notification";
					if(event.notification.header && event.notification.header.length > 0)
					{
						header = event.notification.header;
					}
					
					navigator.notification.alert(message, successHandler, header, "OK");
				}
			});
			
			window.plugins.pushNotification.onDeviceReady({ projectid: push_pushwoosh_senderid, appid : push_pushwoosh_appid });

			// Register device
			window.plugins.pushNotification.registerDevice(
				function(status)
				{
					var pushToken = status;

					// Custom Android Settings
					window.plugins.pushNotification.setMultiNotificationMode();	// Multi notifications
					window.plugins.pushNotification.setEnableLED(true);			// Blink led on push
					window.plugins.pushNotification.setSoundType(2);			// Play default sound on push
					window.plugins.pushNotification.setVibrateType(2);			// Vibrate on push
				},
				function(status)
				{
				}
			);
		}
		else if(device.platform == 'ios' || device.platform == 'iOS')
		{
			// Handle notifications
			document.addEventListener('push-notification', function(event)
			{
				var message = event.notification.aps.alert;

				if(message && messag.length > 0 && message != "null")
				{
					navigator.notification.alert(message, successHandler, "Notification", "OK");
				}

				// Reset badge
				window.plugins.pushNotification.setApplicationIconBadgeNumber(0);
			});

			window.plugins.pushNotification.onDeviceReady({pw_appid:push_pushwoosh_appid});
			
			// Register device
			window.plugins.pushNotification.registerDevice(
				function(status)
				{
					var pushToken = status;
				},
				function(status)
				{
				}
			);
			
			// Reset badge
			window.plugins.pushNotification.setApplicationIconBadgeNumber(0);
		}
		else
		{
			document.addEventListener('push-notification', function(event)
			{
				var message = event.notification.title;
	
				if(message && message.length > 0 && message != "null")
				{
					navigator.notification.alert(message, successHandler, "Notification", "OK");
				}
			});
		 
			window.plugins.pushNotification.onDeviceReady({ appid: push_pushwoosh_appid, serviceName: "" });
		 
			window.plugins.pushNotification.registerDevice(
				function(status)
				{
					var pushToken = status;
				},
				function(status)
				{
				}
			);
		}
	}
}

/*
 * Setup Push Notifications with PushWoosh
 */
function bt_setup_push_pushapps()
{
	if(typeof PushNotification !== 'undefined')
	{
		// Handle notifications
		document.addEventListener('pushapps.message-received', function(event)
		{
			if(device.platform == "iOS" || device.platform == "ios")
			{
				var message = event.notification.aps.alert;

				if(message && message.length > 0 && message != "null")
				{
					var header = "Notification";
					if(event.Title && event.Title.length > 0)
					{
						header = event.Title;
					}
					navigator.notification.alert(message, successHandler, header, "OK");
				}
			}
			else
			{
				var message = event.notification.Message;
				if(message && message.length > 0 && message != "null")
				{
					var header = "Notification";
					if(event.notification.header && event.notification.header.length > 0)
					{
						header = event.notification.header;
					}
				
					navigator.notification.alert(message, successHandler, header, "OK");
				}
			}
		});

		// Register device
		PushNotification.registerDevice(push_pushapps_senderid,	push_pushapps_token, function(status)
		{
			//var pushToken = status;
		},
		function(status)
		{
		});
				
		PushNotification.getDeviceId(function (deviceId)
		{
			//console.log("Your device ID: " + deviceId);
		},
		function (error)
		{
		});
	}
}

/*
 * Setup Push Notifications with Urban Airship
 */
function bt_setup_push_urbanairship()
{
	document.addEventListener("urbanairship.registration", function (event)
	{
		if(!event.error)
		{
			//console.log("Registered with ID: " + event.pushID);
		} 
	}, false);

	document.addEventListener("urbanairship.push", function (event)
	{
		var header = "Notification";
		if(event.extras.title)
		{
			header = event.extras.title;
		}
		
		navigator.notification.alert(event.message, successHandler, header, "OK");
	}, false);
}

/*
 * Setup Push Notifications with Infobip
 */
function bt_setup_push_infobip()
{
	if(typeof push !== 'undefined')
	{
		push.initialize(function(event, notification)
		{
			if(event == "onNotificationReceived")
			{
				var header = "Notification";
				if(notification.title)
				{
					header = notification.title;
				}
				navigator.notification.alert(notification.message, successHandler, header, "OK");
				push.notifyNotificationOpened(notification);
			}
		});

		push.register({
			senderId: push_infobip_senderid,
			applicationId: push_infobip_id,
			applicationSecret: push_infobip_secret,
		});
	}
}

/*
 * Setup Push Notifications with IBM
 */
function bt_setup_push_ibm()
{
	var ibmbluemix, ibmpush;
	var values = {
		applicationId: push_ibm_id,
		applicationRoute: push_ibm_route,
		applicationSecret: push_ibm_secret,
	};

	ibmbluemix = IBMBluemix.hybrid;
	ibmpush = IBMPush.hybrid;

	ibmbluemix.initialize(values).then(function(status)
	{
		return ibmpush.initializeService();
	},
	function (err)
	{
		// console.error("IBM Bluemix initialized failed" , err);
	})
	
	.then(function(pushObj)
	{
		push = pushObj;
		return push.registerDevice(device.uuid, device.model + "_" + device.uuid, "onNotificationIBM");
	}, function (err)
	{
		//console.error("IBM Bluemix Push initialized failed" , err);
	}); 
}

/*
 * Setup BuildTool Analytics
 */
function bt_setup_stats_bt()
{
	// Sends stats to BuildTool, and let BuildTool handle it ;-)
	$.get( bt_location + "?stats", {"app_id": bt_app_id, "device_model": device.model, "device_os": device.platform, "device_version": device.version, "device_id": device.uuid});
}

/*
 * Setup Google Analytics
 */
function bt_setup_stats_ga()
{
	if(typeof GAPlugin !== 'undefined')
	{
		GAPlugin.init(successHandler, errorHandler, stats_ga_accountid, 10);
		GAPlugin.trackPage(successHandler, errorHandler, "/index");
	}
}

/*
 * Setup Distimo Analytics
 */
function bt_setup_stats_distimo()
{
	if(typeof window.DistimoSDK !== 'undefined')
	{
		window.DistimoSDK.start(stats_distimo_sdkkey);
	}
}

/*
 * Setup Tapstream
 */
function bt_setup_stats_tapstream()
{
	if(typeof window.tapstream !== 'undefined')
	{
		window.tapstream.create(stats_tapstream_accountname, stats_tapstream_sdksecret, {
			idfa: stats_tapstream_idfa
		});
	}
}

/*
 * Setup Zendrive
 */
function bt_setup_stats_zendrive()
{
	cordova.exec(callback, function(err){},"Zendrive","setup", [ stats_zendrive_key, device.uuid ]);
}

/*
 * Setup Telerik
 */
function bt_setup_stats_telerik()
{
	var factory = window.plugins.EqatecAnalytics.Factory;       
	var settings = factory.CreateSettings(stats_telerik_key);
	settings.LoggingInterface = factory.CreateTraceLogger();
	factory.CreateMonitorWithSettings(settings,
	function()
	{
		//console.log("Monitor created");
		window.plugins.EqatecAnalytics.Monitor.Start(function()
		{
			//console.log("Monitor started");
		});
	},
	function(msg)
	{
		//console.log("Error creating monitor: " + msg);
	});
}

/*
 * Setup Appsee
 */
function bt_setup_stats_appsee()
{
	if(typeof Appsee !== 'undefined')
	{
		Appsee.start(stats_appsee_key);
	}
}

/*
 * Setup iAd
 */
function bt_setup_ads_iad()
{
	if(iAd)
	{
		if(device.platform == 'ios' || device.platform == 'iOS')
		{
			if(ads_iads_type != "INTERSTITIAL")
			{
				if(ads_iads_overlap == 'true')
				{
					banneroverlap = true;
				}
				else
				{
					banneroverlap = false;
				}
				
				iAd.createBanner(
				{
					overlap: banneroverlap, 
					position: ads_iads_position,
					autoShow: true
				});
			}
			else
			{
				iAd.prepareInterstitial(
				{
					autoShow: true
				});
				
				// iAd.showInterstitial();
			}
		}
	}
}

/*
 * Setup AdMob
 */
function bt_setup_ads_admob()
{
	if(AdMob)
	{
		if(device.platform == 'ios' || device.platform == 'iOS')
		{
			var bannerid = ads_admob_ioskey;
		}
		else if(device.platform == 'android' || device.platform == 'Android')
		{
			var bannerid = ads_admob_androidkey;
		}
		else
		{
			var bannerid = ads_admob_winphonekey;
		}
		
		if(ads_admob_type != "INTERSTITIAL")
		{
			if(ads_admob_overlap == 'true')
			{
				var banneroverlap = true;
			}
			else
			{
				var banneroverlap = false;
			}

			AdMob.createBanner(
			{
				adId: bannerid, 
				adSize: ads_admob_type,
				overlap: banneroverlap, 
				position: ads_admob_position,
				autoShow: true
			});
		}
		else
		{
			AdMob.prepareInterstitial(
			{
				adId: bannerid,
				autoShow: true
			});
			
			// AdMob.showInterstitial();
		}
	}
}

/*
 * Setup FacebookAds
 */
function bt_setup_ads_facebook()
{
	if(FacebookAds)
	{
		if(device.platform == 'ios' || device.platform == 'iOS')
		{
			var bannerid = ads_facebook_ios_id;
		}
		else if(device.platform == 'android' || device.platform == 'Android')
		{
			var bannerid = ads_facebook_android_id;
		}

		if(ads_facebook_type != "INTERSTITIAL")
		{
			if(ads_facebook_overlap == 'true')
			{
				var banneroverlap = true;
			}
			else
			{
				var banneroverlap = false;
			}
			
			FacebookAds.createBanner(
			{
				adId : bannerid,
				overlap : banneroverlap,
				adSize : ads_facebook_type,
				position : ads_facebook_position,
				autoShow: true
			});
		}
		else
		{
			FacebookAds.prepareInterstitial(
			{
				adId: bannerid,
				autoShow: true
			});
			
			// FacebookAds.showInterstitial();
		}
	}
}

/*
 * Setup Inmobi
 */
function bt_setup_ads_inmobi()
{
	if(ads_inmobi_position == 'top')
	{
		$('<div id="bt-ad"></div>').prependTo('body');
	}
	else
	{
		$('<div id="bt-ad"></div>').appendTo('body');
	}
	
	if(ads_inmobi_type != '14' && ads_inmobi_type != '16' && ads_inmobi_type != '17' && ads_inmobi_type != '33' && ads_inmobi_type != '34')
	{
		inmobi_conf = {
			siteid : ads_inmobi_siteid,
			slot : ads_inmobi_type,
			test : false,
			manual : false
		};
		
		$.getScript("http://cf.cdn.inmobi.com/ad/inmobi.js").done(function(script, textStatus)
		{
			_inmobi.getNewAd(document.getElementById('bt-ad'), inmobi_conf);
		});
	}
	else
	{
		inmobi_conf = {
			siteid : ads_inmobi_siteid,
			slot : ads_inmobi_type,
			adtype : "int",
			test : false,
			manual : false
		};
		
		$.getScript("http://cf.cdn.inmobi.com/ad/inmobi.js").done(function(script, textStatus)
		{
			_inmobi.getNewAd(document.getElementById('bt-ad'), inmobi_conf);
			_inmobi.addEventListener("close", function(event)
			{
				$('#bt-ad').hide();
			});
		});
	}
}

/*
 * Setup Flurry Ads
 */
function bt_setup_ads_flurry()
{
	if(FlurryAds)
	{
		if(device.platform == 'ios' || device.platform == 'iOS')
		{
			var bannerid = ads_flurry_ios_id;
		}
		else if(device.platform == 'android' || device.platform == 'Android')
		{
			var bannerid = ads_flurry_android_id;
		}

		if(ads_flurry_type != "INTERSTITIAL")
		{
			if(ads_flurry_overlap == 'true')
			{
				var banneroverlap = true;
			}
			else
			{
				var banneroverlap = false;
			}
			
			FlurryAds.createBanner(
			{
				adId : bannerid,
				overlap : banneroverlap,
				adSize : ads_flurry_type,
				position : ads_flurry_position,
				autoShow: true
			});
		}
		else
		{
			FlurryAds.prepareInterstitial(
			{
				adId: bannerid,
				autoShow: true
			});
			
			// FlurryAds.showInterstitial();
		}
	}
}

/*
 * Setup Millenial Media Ads
 */
function bt_setup_ads_mmedia()
{
	if(mMedia)
	{
		if(device.platform == 'ios' || device.platform == 'iOS')
		{
			var bannerid = ads_mmedia_ios_id;
		}
		else if(device.platform == 'android' || device.platform == 'Android')
		{
			var bannerid = ads_mmedia_android_id;
		}

		if(ads_mmedia_type != "INTERSTITIAL")
		{
			if(ads_mmedia_overlap == 'true')
			{
				banneroverlap = true;
			}
			else
			{
				banneroverlap = false;
			}
			
			mMedia.createBanner(
			{
				adId : bannerid,
				overlap : banneroverlap,
				adSize : ads_mmedia_type,
				position : ads_mmedia_position,
				autoShow: true
			});
		}
		else
		{
			mMedia.prepareInterstitial(
			{
				adId: bannerid,
				autoShow: true
			});
			
			// mMedia.showInterstitial();
		}
	}
}

/*
 * Setup MobFox Ads
 */
function bt_setup_ads_mobfox()
{
	if(MobFox)
	{
		if(device.platform == 'ios' || device.platform == 'iOS')
		{
			var bannerid = ads_mobfox_ios_id;
		}
		else if(device.platform == 'android' || device.platform == 'Android')
		{
			var bannerid = ads_mobfox_android_id;
		}

		if(ads_mobfox_type != "INTERSTITIAL")
		{
			if(ads_mobfox_overlap == 'true')
			{
				var banneroverlap = true;
			}
			else
			{
				var banneroverlap = false;
			}
			
			MobFox.createBanner(
			{
				adId : bannerid,
				overlap : banneroverlap,
				adSize : ads_mobfox_type,
				position : ads_mobfox_position,
				autoShow: true
			});
		}
		else
		{
			MobFox.prepareInterstitial(
			{
				adId: bannerid,
				enableVideo: true,
				autoShow: true
			});
			
			// MobFox.showInterstitial();
		}
	}
}

/*
 * Setup MoPub Ads
 */
function bt_setup_ads_mopub()
{
	if(MoPub)
	{
		if(device.platform == 'ios' || device.platform == 'iOS')
		{
			var bannerid = ads_mopub_ios_id;
		}
		else if(device.platform == 'android' || device.platform == 'Android')
		{
			var bannerid = ads_mopub_android_id;
		}

		if(ads_mopub_type != "INTERSTITIAL")
		{
			if(ads_mopub_overlap == 'true')
			{
				var banneroverlap = true;
			}
			else
			{
				var banneroverlap = false;
			}
			
			MoPub.createBanner(
			{
				adId : bannerid,
				overlap : banneroverlap,
				adSize : ads_mopub_type,
				position : ads_mopub_position,
				autoShow: true
			});
		}
		else
		{
			MoPub.prepareInterstitial(
			{
				adId: bannerid,
				autoShow: true
			});
			
			// MoPub.showInterstitial();
		}
	}
}

/*
 * Hide Statusbar on iOS7
 */
function bt_setup_ios_hidestatusbar()
{
	if(typeof StatusBar !== 'undefined')
	{
		if (device.platform == 'ios' || device.platform == 'iOS')
		{
			StatusBar.hide();
		}
	}
}

/*
 * Overlay Statusbar on iOS7
 */
function bt_setup_ios_overlaystatusbar()
{
	if(typeof StatusBar !== 'undefined')
	{
		if (device.platform == 'ios' || device.platform == 'iOS')
		{
			StatusBar.overlaysWebView(true);
			
			if(specific_ios_statusbarstyle == "default")
			{
				StatusBar.styleDefault();
			}
			else if(specific_ios_statusbarstyle == "lightcontent")
			{
				StatusBar.styleLightContent();
			}
			else if(specific_ios_statusbarstyle == "blackopaque")
			{
				StatusBar.styleBlackOpaque();
			}
			else if(specific_ios_statusbarstyle == "blacktranslucent")
			{
				StatusBar.styleBlackTranslucent();
			}
		}
	}
}

/*
 * Setup iOS App Rating
 */
function bt_setup_rate()
{
	if(typeof AppRate !== 'undefined')
	{
		if (device.platform == 'android' || device.platform == 'Android')
		{
			if(rate_android_enable == "1")
			{
				AppRate.preferences.storeAppURL.android = 'market://details?id=' + bt_app_identifier;
				AppRate.promptForRating();
			}
		}
		else if (device.platform == 'ios' || device.platform == 'iOS')
		{
			if(rate_ios_enable == "1" && rate_ios_appid != "")
			{
				AppRate.preferences.storeAppURL.ios = '' + rate_ios_appid + '';
				AppRate.promptForRating();
			}
		}
		else
		{
			if(rate_winphone_enable == "1")
			{
				AppRate.preferences.storeAppURL.windows8 = 'ms-windows-store:Review?name=' + bt_app_identifier;
				AppRate.promptForRating();
			}
		}
	}
}

/*
 * Setup Testflight
 */
function bt_setup_testflight()
{
	if(typeof TestFlight !== 'undefined')
	{
		if(testing_testflight_token != '')
		{
			TestFlight.takeOff(successHandler, errorHandler, testing_testflight_token);
		}
	}
}

/*
 * Setup Lookback
 */
function bt_setup_lookback()
{
	if(typeof window.Lookback !== 'undefined')
	{
		if(testing_lookback_token != '')
		{
			window.Lookback.setupWithAppToken(testing_lookback_token);
			window.Lookback.shakeToRecord(true);
		}
	}
}

/*
 * Setup Repro
 */
function bt_setup_repro()
{
	if(typeof Repro !== 'undefined')
	{
		if(testing_repro_token != '')
		{
			Repro.setup(testing_repro_token);
			Repro.startRecording();
		}
	}
}

/* --------------------------------------------------------------------------------------------------- */

function onNotificationAPN(e)
{
	if (e.alert)
	{	
		var header = "Notification";
		if(e.payload && e.payload.title && e.payload.title.length > 0 && e.payload.title != "null")
		{
			header = e.payload.title;
		}
	
		navigator.notification.alert(
			e.alert,
			function()
			{
				window.plugins.pushNotification.setApplicationIconBadgeNumber(successHandler, errorHandler, 0);
			},
			header,
			"OK"
		);
	}
		
	if (e.sound)
	{
		var snd = new Media(e.sound);
		snd.play();
	}

	if (e.badge)
	{
		window.plugins.pushNotification.setApplicationIconBadgeNumber(successHandler, errorHandler, e.badge);
	}
}

function onNotificationGCM(e)
{
	switch( e.event )
	{
		case 'registered':
		if (e.regid.length > 0)
		{
			$.get( bt_location + "?push", {"app_id": bt_app_id, "device_id": e.regid, "os": "android"});
		}
		break;
		
		case 'message':
		
			var header = "Notification";
			if(e.payload && e.payload.title && e.payload.title.length > 0 && e.payload.title != "null")
			{
				header = e.payload.title;
			}
			
			navigator.notification.alert(e.payload.message, successHandler, header, "OK");
		break;
		
		case 'error':
			// console.log(e.msg);
		break;
		
		default:
		break;
	}
}

function onNotificationIBM(e)
{
	if (e.alert)
	{
		var header = "Notification";
		if(e.payload && e.payload.title && e.payload.title.length > 0 && e.payload.title != "null")
		{
			header = e.payload.title;
		}
		
		navigator.notification.alert(
			e.alert,
			function()
			{},
			header,
			"OK"
		);
	}
}

function onNotificationAPNGameThrive(e)
{
	if (e.alert)
	{
		var header = "Notification";
		if(e.payload && e.payload.title && e.payload.title.length > 0 && e.payload.title != "null")
		{
			header = e.payload.title;
		}
		
		navigator.notification.alert(
			e.alert,
			function()
			{
				window.plugins.GameThrive.setApplicationIconBadgeNumber(successHandler, errorHandler, 0);
			},
			header,
			"OK"
		);
	}
		
	if (e.sound)
	{
		var snd = new Media(e.sound);
		snd.play();
	}

	if (e.badge)
	{
		window.plugins.GameThrive.setApplicationIconBadgeNumber(successHandler, errorHandler, e.badge);
	}
}

function onNotificationGCMGameThrive(e)
{
	switch(e.event)
	{
		case 'registered':
			if (e.regid.length > 0)
			{
				tokenHandlerGameThrive(e.regid);
			}
		break;
		
		case 'message':
			var message = e.payload.alert;
			if(message && message.length > 0 && message != "null")
			{
				var header = "Notification";
				if(e.payload && e.payload.title && e.payload.title.length > 0 && e.payload.title != "null")
				{
					header = e.payload.title;
				}
				
				navigator.notification.alert(message, successHandler, header, "OK");
			}
		break;
		
		case 'error':
			// console.log(e.msg);
		break;
		
		default:
		break;
	}
}

function tokenHandler(token)
{
	$.get(bt_location + "?push", {"app_id": bt_app_id, "device_id": token, "os": "ios"});
}

function tokenHandlerGameThrive(token)
{
	var playerId = window.localStorage.getItem("playerId");
	var device_type = (device.platform == "Android" ? 1 : 0);
	var sendURL;

	if (playerId == null)
	{
		sendURL = "https://gamethrive.com/api/v1/players";
	}
	else 
	{
		sendURL = "https://gamethrive.com/api/v1/players/" + playerId + "/on_session";
	}

	var jsonData = {
		app_id: push_gamethrive_token,
		device_type: device_type,
		identifier: token,
		timezone: (new Date()).getTimezoneOffset() * -60
	};
	
	$.ajax({
		type: "POST",
		dataType: "json",
		url: sendURL,
		data: jsonData,
		success: function(response)
		{
			window.localStorage.setItem("playerId", response.id);
		},
		error: function (e)
		{
		}
	});
}

function successHandler(result)
{
	// console.log(result);
}

function errorHandler(error)
{
	// console.log(error);
}